﻿;CandyProgress... candy-like progressbar with rounded edges and semitransparent overlay-graphics,
;                 length-setting possible, use own transparent png-graphics optionally as edge-icons
;coded 2021 by moefr01
;https://www.autohotkey.com/boards/viewtopic.php?f=10&t=89198
;========================================================================================================================
#NoEnv
#Persistent
#NoTrayIcon
#SingleInstance Force
SetBatchLines -1
SetWinDelay -1
SendMode Input
SetWorkingDir %A_ScriptDir%
;========================================================================================================================
Gui, -DPIScale +E0x02080000				;doublebuffered GUI ...for smoothiness and no flicker! ;-)
Gui, Color, 00B2FF						;GUI windowcolor (see edge of left, middle & right progress-iconparts)
Gui, Font, s8 cFFFFFF, Segoe UI			;font, size & color
Gui, Margin, 20, 20						;margin of controls
;========================================================================================================================
Gui, Add,  Text,     xm  ym   w436 h38  vCandyText  BackgroundTrans Center			;text overlay = topmost
Gui, Add,  Pic,      xm  ym   w18  h38  BackgroundTrans Icon1, cpIconsBlau.icl		;left progresspart w18h38
Gui, Add,  Pic,      x+       w400 h38  BackgroundTrans Icon2, cpIconsBlau.icl		;middle progresspart w400h38
Gui, Add,  Pic,      x+       w18  h38  BackgroundTrans Icon3, cpIconsBlau.icl		;right progresspart w18h38
Gui, Add,  Progress, xm  ym   w436 h38  vCandyProgress ;-Smooth                     ;<= deactivates colorizing
;========================================================================================================================
Gui, Add,  Text,     xm  y120 w38  h76  vCandyTextV BackgroundTrans Center			;text overlay = topmost
Gui, Add,  Pic,      xm  y70  w38  h18  BackgroundTrans Icon4, cpIconsBlau.icl		;top progresspart w38h18
Gui, Add,  Pic,           y+  w38  h100 BackgroundTrans Icon5, cpIconsBlau.icl		;vertical middle progresspart w38h100
Gui, Add,  Pic,           y+  w38  h18  BackgroundTrans Icon6, cpIconsBlau.icl		;bottom progresspart w38h18
Gui, Add,  Progress, xm  y70  w38  h136 vCandyProgressV vertical ;-Smooth           ;<= deactivates colorizing
;========================================================================================================================
Gui, Show, , CandyProgress															;show GUI
;========================================================================================================================
value = 0
Loop {
     if (value >= 33) and (value <= 66)
	    color = FF00FF		;purple
     else if value >= 66
	    color = 0000FF		;blue
     else
	    color = 000000		;black
	 GuiControl, +c%color%, CandyProgress			;set progress color or commentize for -Smooth effect
     GuiControl, , CandyProgress, % abs(value)		;set progress value
	 GuiControl, , CandyText, % abs(value) " %"		;set progress text with % symbol
	 GuiControl, +c%color%, CandyProgressV			;set vertical progress color or commentize for -Smooth effect
     GuiControl, , CandyProgressV, % abs(value)		;set vertical progress value
	 GuiControl, , CandyTextV, % abs(value) "`n%"	;set vertical progress text with % symbol
     value += 1
     if value > 100
	    {
		Sleep, 2000
        value := -value
	    }
     Sleep, 50
     }
Return
;========================================================================================================================
GuiEscape:
GuiClose:
ExitApp